-- Fehlerbehandlung
module Eval2 where

import Term

-- Ergebnistyp: Das Ergebnis der Berechnung, oder ein Fehler
data MayFail a = Result a | Error Cause
    deriving Show

-- Division durch Null ist die einzige Fehlerursache hier.
data Cause = DivisionByZero
    deriving Show

-- | 'eval' berechnet den Wert eines Ausdrucks.
eval :: Term -> MayFail Integer
eval (Const a) = Result a
eval (Binary op a b) = case (eval a) of
    _ -> error "nicht implementiert"

-- | 'evalOp' berechnet das Ergebnis einer binaeren Operation,
-- angewandt auf zwei Operanden.
evalOp :: Op -> Integer -> Integer -> MayFail Integer
evalOp Div a 0 = Error DivisionByZero
-- ...
