-- Aufzeichnung von Zwischenschritten
module Eval5 where

import Term

-- Ergebnistyp: Eine Liste von Logeintraegen, und das Ergebnis der Berechnung
data Log a = Log [LogEntry] a

-- Ein Logeintrag ist eine Zeichenkette
type LogEntry = String

instance Monad Log where
    x >>= f = error "nicht implementiert" -- XXX

    return r = error "nicht implementiert" -- XXX

-- | 'addLog' fuegt einen Eintrag zum Protokoll hinzu
addLog :: LogEntry -> Log ()
addLog e = error "nicht implementiert" -- XXX

-- | 'eval' berechnet den Wert eines Ausdrucks.
eval :: Term -> Log Integer
eval (Const a) = return a
eval (Binary op a b) = do
    a' <- eval a
    b' <- eval b
    logOp op a' b' -- neu!
    evalOp op a' b'

-- | 'evalOp' berechnet das Ergebnis einer binaeren Operation,
-- angewandt auf zwei Operanden.
evalOp :: Op -> Integer -> Integer -> Log Integer
evalOp Add a b = return (a + b)
evalOp Sub a b = return (a - b)
evalOp Mul a b = return (a * b)
evalOp Div a b = return (a `div` b)

-- | 'logOp' erzeugt einen Logeintrag fuer eine binaere Operation
logOp :: Op -> Integer -> Integer -> Log ()
logOp op a b = addLog (unwords [show op, show a, show b])

instance Show a => Show (Log a) where
    show (Log log a) = unlines (log ++ ["-->", show a])
