-- Zaehlen von Operationen
module Eval3 where

import Term

-- 'CountOps a' ist eine Funktion, die einen Anfangswert des Zaehlers
-- uebergeben bekommt, und das Ergebnis der Berechnung sowie den Endwert
-- des Zaehlers zurueckgibt.
type CountOps a = Int -> (a, Int)

-- | 'eval' berechnet den Wert eines Ausdrucks.
eval :: Term -> CountOps Integer
eval (Const a) = \cnt -> (a, cnt)
eval (Binary op a b) = \cnt ->
    let (a', cnt1) = (eval a) cnt
        (b', cnt2) = (eval b) cnt1
        (r, cnt3)  = (evalOp op a' b') cnt2
    in  (r, cnt3 + 1)

-- | 'evalOp' berechnet das Ergebnis einer binaeren Operation,
-- angewandt auf zwei Operanden.
evalOp :: Op -> Integer -> Integer -> CountOps Integer
evalOp Add a b = \cnt -> (a + b, cnt)
evalOp Sub a b = \cnt -> (a - b, cnt)
evalOp Mul a b = \cnt -> (a * b, cnt)
evalOp Div a b = \cnt -> (a `div` b, cnt)

