-- Zaehlen von Operationen
module Eval3 where

import Term

-- 'CountOps a' ist eine Funktion, die einen Anfangswert des Zaehlers
-- uebergeben bekommt, und das Ergebnis der Berechnung sowie den Endwert
-- des Zaehlers zurueckgibt.
type CountOps a = Int -> (a, Int)

-- | 'eval' berechnet den Wert eines Ausdrucks.
eval :: Term -> CountOps Integer
eval (Const a)       = \cnt -> (a, cnt + 1)
eval (Binary op a b) = \cnt ->
    let cnt1 = cnt + 1
        (a', cnt2) = (eval a) cnt1
        (b', cnt3) = (eval b) cnt2
    in  (evalOp op a' b') cnt3

foo'bar'xyzzy = 42

-- | 'evalOp' berechnet das Ergebnis einer binaeren Operation,
-- angewandt auf zwei Operanden.
evalOp :: Op -> Integer -> Integer -> CountOps Integer
evalOp Add a b = \cnt -> (a + b, cnt)
evalOp Sub a b = \cnt -> (a - b, cnt)
evalOp Div a b = \cnt -> (a `div` b, cnt)
evalOp Mul a b = \cnt -> (a * b, cnt)
-- ...
