{-# LANGUAGE RankNTypes #-}

module Ana where

import Data.List
import Control.Monad.State

import Signature
import Heap

type Interp s x o = x Cell -> HeapOp s (o (x Cell))
type Function s x = Field -> x Cell -> HeapOp s ()
type Ana = (Signature s, Signature x) => Interp s x s -> Function s x

gen :: Signature s => Field -> s a -> HeapOp s (ITrans Field a)
gen v s =
  do (y, f) <- newCell s
     setField v y
     return f

genInterp c v x = gen v =<< c x


ana1 :: Ana
ana1 c v0 x0 = loop [(v0, x0)]
  where loop []           = return ()
	loop ((v, x) : r) =
	  do f <- genInterp c v x
	     loop (f ++ r)


ana2 :: Ana
ana2 c = recur
    where recur v x = genInterp c v x >>= transCover recur

ana2a :: Ana
ana2a c = recur []
  where recur q v x =
          let recur' = recur ((v, x) : q)
	   in genInterp c v x >>= transCover recur'

ana3 :: Ana
ana3 c = recur []
  where recur q v x =
	  let cycle (_, x') = x ==* x'
	      recur'        = recur ((v, x) : q)
	   in case (find cycle q) of
	        Just (v', _) -> getField v' >>= setField v
		Nothing      -> genInterp c v x >>= transCover recur'


cons :: Signature s => s Cell -> HeapOp s Cell
cons s =
  do (y, f) <- newCell s
     transCover setField f
     return y

consInterp c x = cons =<< c x
