module Dialgebra where

import Signature


type Cons s a = s a -> a
type Decons s a = a -> s a


-- In Haskell's non-strict semantics, a single datatype is both initial and
-- final model of a signature.

class Signature s => Dialgebra s a where
  cons :: Cons s a
  decons :: Decons s a

-- Iso law: cons . decons = id = decons . cons


-- This can be used to construct katas and anas generically.


kata :: Dialgebra s i => Cons s a -> i -> a
kata f = f . fmap (kata f) . decons

-- Kata law: kata f . cons = f . fmap (kata f)


ana :: Dialgebra s f => Decons s a -> a -> f
ana f = cons . fmap (ana f) . f

-- Ana law: decons . ana f = fmap (ana f) . f

