module Dnf(Dnf(..), dnftrue, dnffalse, dnfor, dnfand) where

newtype Dnf a = Dnf [[a]] deriving Show

dnftrue = Dnf [[]]
dnffalse = Dnf []

dnfand, dnfor :: Dnf a -> Dnf a -> Dnf a
dnfor (Dnf x) (Dnf y) = Dnf (x ++ y)
dnfand (Dnf x) (Dnf y) = Dnf (concat (map (\ z -> map (z ++) y) x))

instance Functor Dnf where
    fmap f (Dnf p) = Dnf (map (map f) p)

instance Monad Dnf where
    return x = Dnf [[x]]
    (Dnf p) >>= f = foldr dnfor dnffalse (map (foldr dnfand dnftrue . map f) p)

instance MonadPlus Dnf where
    mzero = dnffalse
    mplus = dnfor
