{-# LANGUAGE RankNTypes #-}

module Res where

import Signature
import Heap

import Data.List
import Control.Monad
import Control.Monad.Fix

type Pred a = a -> Bool
type Calc a = a -> [[a]]
type Res = Eq a => Calc a -> Pred a
type ERes = Eq a => Calc a -> Pred a -> Pred a

dnf = any . all

res1 :: Res
res1 k r = loop [[r]]
  where loop []            = False
	loop ([] : _)      = True
	loop ((r : s) : t) = loop (map (++ s) (k r) ++ t)


res2 :: Res
res2 k = recur
  where recur p = dnf recur (k p)


res2a :: Res
res2a k = recur []
  where recur s p = let recur' = recur (p : s)
	             in dnf recur' (k p)

res3 :: ERes
res3 k e = recur []
  where recur s p = let recur' = recur (p : s)
		     in if any (== p) s then e p
			else dnf recur' (k p)

res3a :: Eq a => Calc a -> Pred a -> Calc a -> Pred a -> Pred a
res3a k e k' e' = recur []
  where recur s p = if k' p == [] then
		      let recur' = recur (p : s)
		       in if any (== p) s then e p
			  else dnf recur' (k p)
		    else res3 k' e' p

lfp, gfp :: Res
lfp = flip res3 (const False)
gfp = flip res3 (const True )


type Pred' s t = t Cell -> HeapOp s Bool
type Calc' s t = t Cell -> HeapOp s [[t Cell]]

search :: (Signature s, Signature t) => Calc' s t -> Pred' s t -> Pred' s t
search k e = recur []
  where recur q x = let recur' = recur (x : q)
		     in if any (==* x) q then e x
			else dnfM recur' =<< k x

dnfM :: (a -> HeapOp s Bool) -> [[a]] -> HeapOp s Bool
dnfM = anyM . allM

allM p c = return . all id =<< mapM p c
anyM p c = return . any id =<< mapM p c

least k = search k (const $ return False)
greatest k = search k (const $ return True)

