{-# LANGUAGE TypeOperators, TypeSynonymInstances, FlexibleContexts, UndecidableInstances #-}

import Signature
import Ana
import Heap
import Res
import Control.Monad.State
import qualified Data.Map as Map

{-
newtype Fix f = In { out :: f (Fix f) }

data Cell a b = Nil | Cons a b
instance Functor (Cell a) where
  fmap f Nil = Nil
  fmap f (Cons x y) = Cons x (f y)

type List a = Fix (Cell a)
-}

type LSig a = Const () :+: (Const a :*: Identity)

instance (Show a, Show b) => Show (LSig a b) where
  show (Inject1 _) = "[]"
  show (Inject2 ((Const x) :*: (Identity ys))) = show x ++ " : " ++ show ys

map0 :: Eq a => (a -> a) -> Interp (LSig a) Identity (LSig a)
map0 f (Identity x) =
  do c <- getCell x
     case c of
       Inject1 (Const ()) -> return (Inject1 (Const ()))
       Inject2 (Const x :*: Identity ys) -> do d <- getField ys
                                               return (Inject2 (Const (f x) :*: Identity (Identity d)))

data Data = Number Int | String String
  deriving (Eq)

instance Show Data where
  show (Number n) = show n
  show (String s) = show s


instance (Signature s, Show (s Cell)) => Show (Heap s) where
  show h = unlines ("" : map showcell (Map.toList (Map.map unfield (cellsHeap h))))
    where 
      unfield = fmap (\f -> Map.findWithDefault undefined f (fieldsHeap h))
      showcell (x, s) = "  " ++ show x ++ " --> " ++ show s

createWaltz :: HeapOp (LSig Data) Cell
createWaltz =
  do c1 <- freshCell
     c2 <- freshCell
     c3 <- freshCell
     t1 <- freshField
     t2 <- freshField
     t3 <- freshField
     cons c1 1 t1 c2
     cons c2 2 t2 c3
     cons c3 3 t3 c1
     return c1
  where cons c h t d =
          do setCell c (Inject2 (Const (Number h) :*: Identity t))
             setField t d

song (Number 1) = String "Tra"
song (Number 2) = String "li"
song (Number 3) = String "la"

eval = ana3

singWaltz =
  do v <- freshField
     x <- createWaltz
     eval (map0 song) v (Identity x)
     getField v

infi :: Identity Cell -> HeapOp (LSig Data) [[Identity Cell]]
infi (Identity x) =
  do s <- getCell x
     case s of Inject1 _ -> return []
               (Inject2 (_ :*: Identity f)) -> do { y <- getField f ; return [[Identity y]] }

infiWaltz = 
  do x <- singWaltz
     greatest infi (Identity x)
